#ifndef PKMNLIB_TYPEREGISTRY_HPP
#define PKMNLIB_TYPEREGISTRY_HPP

#include <string>
#include "../WebAssemblyScriptResolver.hpp"
#include "Arbutils/Collections/Dictionary.hpp"
#include "Battling/WASMPokemonRegistry.hpp"
#include "Library/LibraryMethods.hpp"
#include "Library/WASMAbilityRegistry.hpp"
#include "Library/WASMEffectParameter.hpp"
#include "Library/WASMFormeRegistry.hpp"
#include "Library/WASMItemRegistry.hpp"
#include "Library/WASMMoveDataRegistry.hpp"
#include "Library/WASMSpeciesRegistry.hpp"
#include "WASMCoreMethods.hpp"
#include "WASMListRegistry.hpp"
#include "WASMStringView.hpp"

class TypeRegistry {
public:
    static void Register(ArbUt::Dictionary<std::string, wasm_func_t*>& externs, WebAssemblyScriptResolver* resolver) {
        WASMCoreMethods::Register(externs, resolver);
        WASMStringView::Register(externs, resolver);
        WASMListRegistry::Register(externs, resolver);

        LibraryMethods::Register(externs, resolver);
        WASMEffectParameter::Register(externs, resolver);
        WASMMoveDataRegistry::Register(externs, resolver);
        WASMItemRegistry::Register(externs, resolver);
        WASMSpeciesRegistry::Register(externs, resolver);
        WASMFormeRegistry::Register(externs, resolver);
        WASMAbilityRegistry::Register(externs, resolver);

        WASMPokemonRegistry::Register(externs, resolver);
    }
};

#endif // PKMNLIB_TYPEREGISTRY_HPP
